package praktikum05;

import java.util.LinkedList;
import java.util.Queue;
import java.util.Random;
import java.util.Scanner;

public class EscapeBot extends Bot {



    private boolean rocketFound = false;

    public static void main(String[] args) {
        EscapeBot escapeBot = new EscapeBot(args);
        escapeBot.run();
    }

    protected EscapeBot(String[] args) {
        super(args);
    }

    @Override
    protected char nextMove(View view) throws Exception {
        if (!rocketFound) {
            return findRocket(view);
        } else {
            return 'q'; // Stoppe die Bewegung, nachdem die Rakete gefunden wurde
        }
    }

    private char findRocket(View view) {
        int positionRocket = view.data.indexOf('o');
        int positionRover = view.data.indexOf('A');

        if (positionRover == positionRocket) {
            rocketFound = true;
            return 'q'; // Wenn der Rover bereits auf der Rakete steht, stoppe die Bewegung
        }

        // Überprüfe, ob die Rakete im Sichtfeld ist
        if (positionRocket > -1) {
            int width = view.width;
            int rowRover = positionRover / width;
            int colRover = positionRover % width;
            int rowRocket = positionRocket / width;
            int colRocket = positionRocket % width;

            // Wenn die Rakete auf der gleichen Zeile ist
            if (rowRover == rowRocket) {
                if (colRocket > colRover) {
                    return '>'; // Bewege dich nach rechts
                } else if (colRocket < colRover) {
                    return '<'; // Bewege dich nach links
                }
            }

            // Wenn die Rakete auf der gleichen Spalte ist
            if (colRover == colRocket) {
                if (rowRocket > rowRover) {
                    return 'v'; // Bewege dich nach unten
                } else if (rowRocket < rowRover) {
                    return '^'; // Bewege dich nach oben
                }
            }
        }

        // Ansonsten, benutze eine zufällige Bewegung
        return moveRandomly();
    }

        private char moveRandomly() {
            Random random = new Random();
            int randomDirection = random.nextInt(4);

            switch (randomDirection) {
                case 0:
                    return '^'; // Vorwärts
                case 1:
                    return 'v'; // Rückwärts
                case 2:
                    return '<'; // Linksdrehung
                case 3:
                    return '>'; // Rechtsdrehung
                default:
                    return 'q'; // Abbruch der Verbindung
            }
        }
    }

